﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;

namespace Microsoft.Samples.Office.UnifiedCommunications.Gadget.Config
{
    [ConfigurationCollection(typeof(ContactElement),
    CollectionType = ConfigurationElementCollectionType.AddRemoveClearMap)]
    public class ContactElementCollection : ConfigurationElementCollection
    {
        #region Constructors
        static ContactElementCollection()
        {
            m_properties = new ConfigurationPropertyCollection();
        }

        public ContactElementCollection()
        {
        }
        #endregion

        #region Fields
        private static ConfigurationPropertyCollection m_properties;
        #endregion

        #region Properties

        protected override ConfigurationPropertyCollection Properties
        {
            get { return m_properties; }
        }

        public override ConfigurationElementCollectionType CollectionType
        {
            get { return ConfigurationElementCollectionType.AddRemoveClearMap; }
        }
        #endregion

        #region Indexers
        public ContactElement this[int index]
        {
            get { return (ContactElement)base.BaseGet(index); }
            set
            {
                if (base.BaseGet(index) != null)
                {
                    base.BaseRemoveAt(index);
                }
                base.BaseAdd(index, value);
            }
        }

        public ContactElement this[object contactID]
        {
            get { return (ContactElement)base.BaseGet(contactID); }
        }
        #endregion

        #region Overrides
        protected override ConfigurationElement CreateNewElement()
        {
            return new ContactElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return (element as ContactElement).ContactID;
        }
        #endregion

        #region Methods

        public void Add(ContactElement contact)
        {
            base.BaseAdd(contact);
        }

        public void Remove(string contactID)
        {
            base.BaseRemove(contactID);
        }

        public void Remove(ContactElement contact)
        {
            base.BaseRemove(GetElementKey(contact));
        }

        public void Clear()
        {
            base.BaseClear();
        }

        public void RemoveAt(int index)
        {
            base.BaseRemoveAt(index);
        }

        public string GetKey(int index)
        {
            return (string)base.BaseGetKey(index);
        }

        #endregion
    }
}
