﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Samples.Office.UnifiedCommunications.Gadget.Config
{
    public struct SettingsEWS
    {
        public SettingsEWS(string emailAddress, string exchangeServer, string domainUser, 
            string password, string ewsUrl, bool? autodiscover, bool? voicemailEnabled, string displayName)
        {
            EmailAddress = emailAddress;
            ExchangeServer = exchangeServer;
            DomainUser = domainUser;
            Password = password;
            EWSUrl = ewsUrl;
            AutoDiscover = autodiscover;
            VoicemailEnabled = voicemailEnabled;
            DisplayName = displayName;
        }

        public string EmailAddress;
        public string ExchangeServer;
        public string DomainUser;
        public string Password;
        public string EWSUrl;
        public bool? AutoDiscover;
        public bool? VoicemailEnabled;
        public string DisplayName;
    }

    public struct SettingsTop5
    {
        public SettingsTop5(bool top5UseIM, bool top5UseCall, bool top5UseEmail, 
            bool top5UseTagged, bool top5UseTeamMember)
        {
            Top5UseIM = top5UseIM;
            Top5UseCall = top5UseCall;
            Top5UseEmail = top5UseEmail;
            Top5UseTagged = top5UseTagged;
            Top5UseTeamMember = top5UseTeamMember;
        }

        public bool Top5UseIM;
        public bool Top5UseCall;
        public bool Top5UseEmail;
        public bool Top5UseTagged;
        public bool Top5UseTeamMember;
    }

    public struct ContactMessage
    {
        public string from;
        public DateTime asOfTime;
        public int count;

        public ContactMessage(string from, DateTime asOfTime, int count)
        {
            this.from = from;
            this.asOfTime = asOfTime;
            this.count = count;
        }
    }
}
