﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Samples.Office.UnifiedCommunications.Gadget.Events
{
    public class Fav5ChangedEventArgs : EventArgs
    {
        public Fav5Operation Operation { get; set; }
        public int OrderKey { get; set; }
        public string SIPUri { get; set; }
        public string DisplayName { get; set; }
        public bool IsPhoneNumber { get; set; }
        public bool? Success { get; set; }

        public Fav5ChangedEventArgs() { }

        public Fav5ChangedEventArgs(Fav5Operation operation)
        {
            this.Operation = operation;
        }

        public Fav5ChangedEventArgs(int orderKey, string sipUri, string displayName,
            bool isPhoneNumber, bool? success)
        {
            this.OrderKey = orderKey;
            this.SIPUri = sipUri;
            this.DisplayName = displayName;
            this.IsPhoneNumber = isPhoneNumber;
            if (success.HasValue)
                this.Success = success;
        }

        public Fav5ChangedEventArgs(Fav5Operation operation, int orderKey, string sipUri,
            string displayName, bool isPhoneNumber, bool? success)
        {
            this.Operation = operation;
            this.OrderKey = orderKey;
            this.SIPUri = sipUri;
            this.DisplayName = displayName;
            this.IsPhoneNumber = isPhoneNumber;
            if (success.HasValue)
                this.Success = success;
        }
    }
}
